defmodule StepFlow.RunWorkflows.NestedWorkflows.ChildWorkflowErrorTest do
  use ExUnit.Case
  use Plug.Test

  alias Ecto.Adapters.SQL.Sandbox
  alias StepFlow.Amqp.CommonEmitter
  alias StepFlow.Progressions.Progression
  alias StepFlow.Step
  alias StepFlow.WorkflowDefinitions
  alias StepFlow.Workflows

  doctest StepFlow

  setup do
    # Explicitly get a connection before each test
    :ok = Sandbox.checkout(StepFlow.Repo)
    # Setting the shared mode
    Sandbox.mode(StepFlow.Repo, {:shared, self()})
    {_conn, channel} = StepFlow.HelpersTest.get_amqp_connection()

    on_exit(fn ->
      StepFlow.HelpersTest.consume_messages(channel, "job_test", 3)
    end)

    :ok
  end

  describe "workflows" do
    @workflow_definition %{
      schema_version: "1.9",
      identifier: "id",
      version_major: 6,
      version_minor: 5,
      version_micro: 4,
      reference: "some id",
      icon: "custom_icon",
      label: "Two steps workflow",
      tags: ["test"],
      parameters: [
        %{
          id: "input_video",
          type: "string",
          value: "test.mov"
        }
      ],
      steps: [
        %{
          id: 0,
          name: "job_test",
          icon: "step_icon",
          label: "My first step",
          mode: "workflow_one_for_one",
          skip_destination_path: true,
          parameters: [
            %{
              id: "source_paths",
              type: "array_of_templates",
              value: ["{input_video}"]
            },
            %{
              id: "destination_path",
              type: "string",
              value: "my_output.mp3"
            },
            %{
              id: "identifier",
              type: "string",
              value: "one_step_workflow"
            },
            %{
              id: "version_major",
              type: "integer",
              value: 6
            },
            %{
              id: "version_minor",
              type: "integer",
              value: 5
            },
            %{
              id: "version_micro",
              type: "integer",
              value: 4
            },
            %{
              id: "parameters",
              type: "extended",
              value: [
                %{
                  id: "this_input_video",
                  type: "template",
                  value: "{source_path}"
                }
              ]
            }
          ]
        },
        %{
          id: 1,
          name: "job_test",
          icon: "step_icon",
          label: "My second step",
          parent_ids: [0],
          required_to_start: [0],
          parameters: []
        }
      ]
    }

    @tag capture_log: true
    test "run nested workflow with 2 steps and one source path with error in child workflow" do
      WorkflowDefinitions.load_workflows_in_database()

      workflow = StepFlow.HelpersTest.workflow_fixture(@workflow_definition)
      StepFlow.HelpersTest.admin_role_fixture()

      {:ok, "started"} = Step.start_next(workflow)
      Workflows.Status.define_workflow_status(workflow.id, :created_workflow)

      StepFlow.HelpersTest.check(workflow.id, 1)
      StepFlow.HelpersTest.check(workflow.id, 0, 1)

      child_workflow =
        Workflows.list_workflows(%{
          reference: "[AUTOGENERATED] Child from workflow #{workflow.id}",
          roles: ["administrator"]
        }).data
        |> List.first()

      {:ok, "still_processing"} = Step.start_next(child_workflow)

      StepFlow.HelpersTest.check(child_workflow.id, 1)
      StepFlow.HelpersTest.check(child_workflow.id, 0, 1)

      # Send job completion message
      child_workflow = Workflows.get_workflow!(child_workflow.id)
      StepFlow.HelpersTest.change_job_status(child_workflow, 0, :processing)

      Workflows.Status.define_workflow_status(
        child_workflow.id,
        :job_progression,
        %Progression{progression: 0}
      )

      job_id = List.first(child_workflow.jobs).id

      CommonEmitter.publish_json(
        "job_error",
        0,
        %{
          job_id: job_id,
          status: "error",
          error: "Error"
        },
        "job_response"
      )

      :timer.sleep(500)

      assert :error == Workflows.Status.get_last_workflow_status(workflow.id).state
    end

    @tag capture_log: true
    test "run nested workflow with 2 steps and one source path with error in child workflow with another error message" do
      WorkflowDefinitions.load_workflows_in_database()

      workflow = StepFlow.HelpersTest.workflow_fixture(@workflow_definition)
      StepFlow.HelpersTest.admin_role_fixture()

      {:ok, "started"} = Step.start_next(workflow)
      Workflows.Status.define_workflow_status(workflow.id, :created_workflow)

      StepFlow.HelpersTest.check(workflow.id, 1)
      StepFlow.HelpersTest.check(workflow.id, 0, 1)

      child_workflow =
        Workflows.list_workflows(%{
          reference: "[AUTOGENERATED] Child from workflow #{workflow.id}",
          roles: ["administrator"]
        }).data
        |> List.first()

      {:ok, "still_processing"} = Step.start_next(child_workflow)

      StepFlow.HelpersTest.check(child_workflow.id, 1)
      StepFlow.HelpersTest.check(child_workflow.id, 0, 1)

      # Send job completion message
      child_workflow = Workflows.get_workflow!(child_workflow.id)
      StepFlow.HelpersTest.change_job_status(child_workflow, 0, :processing)

      Workflows.Status.define_workflow_status(
        child_workflow.id,
        :job_progression,
        %Progression{progression: 0}
      )

      job_id = List.first(child_workflow.jobs).id

      CommonEmitter.publish_json(
        "job_error",
        0,
        %{
          job_id: job_id,
          status: "error",
          parameters: [
            %{
              id: "message",
              type: "string",
              value: "Error"
            }
          ]
        },
        "job_response"
      )

      :timer.sleep(3000)

      assert :error == Workflows.Status.get_last_workflow_status(workflow.id).state
    end
  end
end
